function phan=findObjectPositions(phan,label)
% given a phan with a masterLabelImg and a label index
% find the positions (both centroids and linearly weighted
    propList={ 'Area','Centroid','PixelList','PixelIdxList'};
    work=(phan.masterLabelImg==label);
    if(sum(work(:))==0) 
        % no matches on this label 
        return;
    end
    regionLabelImg=bwlabeln(work);
    props=regionprops(regionLabelImg,propList);
    try
    phan.SphereProps(label)=props;
    catch
            save;
            quit;
    end
    locations=props(1).PixelList;
    intensities=phan.img(props.PixelIdxList);
       % we have to swizzle x,y since regionprops is mildly retarded
    locations(:,[1,2])=locations(:,[2 1]);
    graySum=sum(intensities);
    xpos=sum(intensities.*locations(:,1))/graySum;
    ypos=sum(intensities.*locations(:,2))/graySum;
    zpos=sum(intensities.*locations(:,3))/graySum;
    % xpos,ypos,zpos are reckoned in terms of voxels
    % now scribble this information down
    phan.intensityMean(label)=mean(intensities);
    phan.intensityStd(label)=std(intensities); 
    phan.voxCentroids(label,1:3)=[props.Centroid(2),props.Centroid(1),props.Centroid(3)];    
    tmp=[phan.voxCentroids(label,1:3),1];
    tmp=phan.RAS*tmp';
    phan.RASCentroids(label,1:3) = tmp(1:3)';
    tmp=[xpos,ypos,zpos,1];
    tmp=phan.RAS*tmp';
    phan.RASPositions(label,1:3) = tmp(1:3)';
    return;
end