

Directory = '/localhome2/blezek/MION/CalibrationData/2002-11-14-NonlinearScan/';
Directory = '/home/blezek/src/MION/CalibrationData/2002-11-14-NonlinearScan/';

WarpedData = [];
UnwarpedData = [];

disp ( sprintf ( 'Scan\tSeries\tThreshold\tPixels\tArea\tThreshold\tPixels\tArea' ) );
for ToWarpOrNot = 1:2
  Prefix = 'WarpedWaterPhantom';
  if ToWarpOrNot == 1
    Prefix = 'UnwarpedWaterPhantom';
  end
  for SeriesId = 2:14
  
    AnalyzeFileName = fullfile ( Directory, sprintf ( '%s%d', Prefix, SeriesId ) );
    Image = LoadAnalyzeImage ( AnalyzeFileName );

    Image = squeeze ( Image );
    
    t = OtsuThreshold ( Image );
    PixelCount = 0;
    Area = 0;
    for Z = 1:size(Image,3)
      [P, A] = SliceArea ( Image(:,:,Z), t );
      PixelCount = PixelCount + P;
      Area = Area + A;
    end
    
    PixelCount1 = PixelCount;
    Area1 = Area;
    t1 = t;

    % Sort of a Image < t
    t = t + 1;
    PixelCount = 0;
    Area = 0;
    for Z = 1:size(Image,3)
      [P, A] = SliceArea ( Image(:,:,Z), t );
      PixelCount = PixelCount + P;
      Area = Area + A;
    end
    PixelCount2 = PixelCount;
    Area2 = Area;
    t2 = t;
    
    disp ( sprintf ( '%s\t%d\t%d\t%f\t%f\t%d\t%f\t%f', ...
                     Prefix, SeriesId, ...
                     t1, PixelCount1, Area1, ...
                     t2, PixelCount2, Area2 ) );
    
    if ToWarpOrNot == 1
      UnwarpedData(SeriesId,:) = [t1, PixelCount1, Area1, t2, PixelCount2, Area2];
    else
      WarpedData(SeriesId,:) = [t1, PixelCount1, Area1, t2, PixelCount2, Area2];
    end
  end
end



Idx = 2:14;
figure ( 1 );
clf
subplot ( 221 )
NFactor = UnwarpedData(Idx(1), 3 );
plot ( Idx, WarpedData(Idx,3 ) ./ NFactor - 1, Idx, UnwarpedData(Idx,3) ./ NFactor - 1, 'g' )
legend ( 'Corrected', 'Raw' )
title ( 'Edge based volume calculation (normalized)' ) 

subplot ( 222 )
NFactor = UnwarpedData(Idx(1), 2 );
plot ( Idx, WarpedData(Idx,2 ) ./ NFactor - 1, Idx, UnwarpedData(Idx,2) ./ NFactor - 1, 'g' )
legend ( 'Corrected', 'Raw' )
title ( 'Threshold based volume calculation (normalized)' ) 


subplot ( 223 )
NFactor = UnwarpedData(Idx(1),2);
DUnwarped = ( UnwarpedData(Idx,2) - UnwarpedData(Idx,3) ) ./ NFactor;
DWarped = ( WarpedData(Idx,2) - WarpedData(Idx,3) ) ./ NFactor;

plot ( Idx, DWarped, Idx, DUnwarped, 'g' )
legend ( 'Corrected', 'Raw' )
title ( 'Threshold / Edge difference' );


plot ( Idx, WarpedData(Idx,2) - WarpedData(Idx,2) ) )



