function [PathNames,FileNames,varargout] = MakeFileList(varargin);
% MAKEFILELIST Application M-file for MakeFileList.fig
%    FIG = MAKEFILELIST launch MakeFileList GUI.
%    MAKEFILELIST('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.0 26-Feb-2002 10:41:28

global PathNames FileNames;
global OriginalDirectory TempDirectory;


if nargin == 2  % LAUNCH GUI

	fig = openfig(mfilename,'reuse');

	% Use system color scheme for figure:
	set(fig,'Color',get(0,'defaultUicontrolBackgroundColor'));

	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
	guidata(fig, handles);
    %This Section added by Rich
    PathNames=varargin{1};
    FileNames=varargin{2};
    if length(PathNames)>0
        InitList=strcat(PathNames,FileNames);
    else
        InitList=[];
    end
    set(handles.listbox1,'String',InitList);
    
    %Temporarily change current directory
    
    OriginalDirectory=cd;
    TempDirectory='C:\Volumetrics\ImageFiles';
    TempDirectory='/tmp';
    

	% Wait for callbacks to run and window to be dismissed:
	uiwait(fig);

	if nargout > 1
		varargout{1} = fig;
	end

elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK
    
	try
		[varargout{1:nargout-1}] = feval(varargin{:}); % FEVAL switchyard
	catch
		disp(lasterr);
	end

end


%| ABOUT CALLBACKS:
%| GUIDE automatically appends subfunction prototypes to this file, and 
%| sets objects' callback properties to call them through the FEVAL 
%| switchyard above. This comment describes that mechanism.
%|
%| Each callback subfunction declaration has the following form:
%| <SUBFUNCTION_NAME>(H, EVENTDATA, HANDLES, VARARGIN)
%|
%| The subfunction name is composed using the object's Tag and the 
%| callback type separated by '_', e.g. 'slider2_Callback',
%| 'figure1_CloseRequestFcn', 'axis1_ButtondownFcn'.
%|
%| H is the callback object's handle (obtained using GCBO).
%|
%| EVENTDATA is empty, but reserved for future use.
%|
%| HANDLES is a structure containing handles of components in GUI using
%| tags as fieldnames, e.g. handles.figure1, handles.slider2. This
%| structure is created at GUI startup using GUIHANDLES and stored in
%| the figure's application data using GUIDATA. A copy of the structure
%| is passed to each callback.  You can store additional information in
%| this structure at GUI startup, and you can change the structure
%| during callbacks.  Call guidata(h, handles) after changing your
%| copy to replace the stored original so that subsequent callbacks see
%| the updates. Type "help guihandles" and "help guidata" for more
%| information.
%|
%| VARARGIN contains any extra arguments you have passed to the
%| callback. Specify the extra arguments by editing the callback
%| property in the inspector. By default, GUIDE sets the property to:
%| <MFILENAME>('<SUBFUNCTION_NAME>', gcbo, [], guidata(gcbo))
%| Add any extra arguments after the last argument, before the final
%| closing parenthesis.



% --------------------------------------------------------------------
function varargout = listbox1_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.listbox1.



% --------------------------------------------------------------------
function varargout = add_file_pushbutton_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.add_file_pushbutton.

global PathNames FileNames;
global OriginalDirectory TempDirectory;
Files=get(handles.listbox1,'String');
numFiles=length(PathNames);

%Temporarily change directory
cd(TempDirectory);
[filename,pathname]=uigetfile('*.*','Select File');
PathNames{numFiles+1,1}=pathname;
FileNames{numFiles+1,1}=filename;
Files=strcat(PathNames,FileNames);
set(handles.listbox1,'String',Files);

cd(OriginalDirectory);



% --------------------------------------------------------------------
function varargout = remove_file_pushbutton_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.remove_file_pushbutton.

global PathNames FileNames;

Files=get(handles.listbox1,'String');
which=get(handles.listbox1,'Value');

PathNames(which,:)=[];
FileNames(which,:)=[];
Files=strcat(PathNames,FileNames);

set(handles.listbox1,'Value',1);
set(handles.listbox1,'String',Files);



% --------------------------------------------------------------------
function varargout = clear_all_pushbutton_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.clear_all_pushbutton.

global PathNames FileNames;

set(handles.listbox1,'String',[]);
PathNames=[];
FileNames=[];



% --------------------------------------------------------------------
function varargout = finish_pushbutton_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.finish_pushbutton.
global PathNames FileNames;

close(handles.MakeFileFig);





