function P = PolyFitFunction ( Xin, T )
% P = PolyFitFunction ( X, A )
% Conforms to the requirements of maketform as an inverse function
% Essentially a wrapper around EvalPolyFit
% X is the input points P x 3
% A is the weights matrix calculated by FitSpheres

  
  if isfield ( T, 'tdata' )
    A = T.tdata;
  else
    A = T;
  end
  
  P = zeros ( size ( Xin ) );
  [r,c] = size ( Xin );
  for row = 1:r
    X = Xin(row,:);
    G=EvalRowG(X);
    P(row,:) = X + G*A;
  end

  