% Dump coordinate transforms.
Directory = '/home/blezek/src/MION/CalibrationData/2002-11-14-ReproducibilityScan/';
[Header Image] = geread ( [Directory 'RawData/E29S1I1.MR'], 'esm' );

T = CoordinateSystems ( Header );
T1 = inv ( T );
save ( [Directory 'Series1VoxelToRAS.mat'], 'T', '-DOUBLE', '-ASCII' )
save ( [Directory 'Series1RASToVoxel.mat'], 'T1', '-DOUBLE', '-ASCII' )

Directory = '/home/blezek/src/MION/CalibrationData/2002-11-14-ScalingScan/';
[Header Image] = geread ( [Directory 'RawData/E30S1I1.MR'], 'esm' );

T = CoordinateSystems ( Header );
T1 = inv ( T );
save ( [Directory 'Series1VoxelToRAS.mat'], 'T', '-DOUBLE', '-ASCII' )
save ( [Directory 'Series1RASToVoxel.mat'], 'T1', '-DOUBLE', '-ASCII' )


Directory = '/home/blezek/src/MION/CalibrationData/2002-11-14-NonlinearScan/';
for series = 1:11
  fn = sprintf ( 'RawData/E35S%dI1.MR', series );
  [Header Image] = geread ( [Directory 'RawData/E35S6I1.MR'], 'esm' );
  T = CoordinateSystems ( Header );
  T1 = inv ( T );
  prefix = sprintf ( 'CalibrationSeries%d', series );
  save ( [Directory prefix 'VoxelToRAS.mat'], 'T', '-DOUBLE', '-ASCII' )
  save ( [Directory prefix 'RASToVoxel.mat'], 'T1', '-DOUBLE', '-ASCII' )
end

% These two scans happen to be in the same coordinate system!

% Now the volume phantom
Directory = '/home/blezek/src/MION/CalibrationData/2002-11-14-NonlinearScan/';
for series = 1:17,
  fn = sprintf ( 'RawData/E36S%dI1.MR', series );
  [Header Image] = geread ( [Directory fn], 'esm' );
  T = CoordinateSystems ( Header );
  
  
  T1 = inv ( T );
  fn = sprintf ( 'Series%d', series );
  save ( [Directory fn 'VoxelToRAS.mat'], 'T', '-DOUBLE', '-ASCII' )
  save ( [Directory fn 'RASToVoxel.mat'], 'T1', '-DOUBLE', '-ASCII' )
end



Directory = '/home/blezek/src/MION/CalibrationData/2002-11-14-ReproducibilityScan/';
for series = 1:5,
  disp ( series );
  [Image, Headers] = LoadSeries ( '/home/blezek/src/MION/CalibrationData/2002-11-14-ReproducibilityScan/RawData/', 29, series );
  % Segment the spheres for this scan
  Image = squeeze ( Image );
  Properties = SegmentSpheres ( Headers(1), Image, 0.5 );
  
  if series == 1
    for p = 1:length(Properties)
      Properties(p).Match = p
    end
    BaseProperties = Properties;
  else
    % Try to match each sphere with it's best neighbor, changing
    % the ID appropriately. Assume the same number of spheres
    BaseCOM = [BaseProperties.COM];
    for p = 1:length(Properties)
      Position = repmat ( Properties(p).COM, 1, length(Properties) );
      D = BaseCOM - Position;
      D = sum ( D.^2 );
      [bogus I] = sort ( D );
      Properties(p).Match = I(1);
    end
  end
  
  fn = sprintf ( '%sSeries%d.txt', Directory, series );
  fid = fopen ( fn, 'w' );
  DumpSpheres ( Properties, fid );
  fclose ( fid );
  
end


% And the scaling scan
Directory = '/home/blezek/src/MION/CalibrationData/2002-11-14-ScalingScan/';
for series = 1:6,
  disp ( series );
  [Image, Headers] = LoadSeries ( [Directory 'RawData/'], 30, series );
  
  % Segment the spheres for this scan
  Image = squeeze ( Image );
  Properties = SegmentSpheres ( Headers(1), Image, 0.5 );

  if series == 1
    for p = 1:length(Properties)
      Properties(p).Match = p
    end
    BaseProperties = Properties;
  else
    % Try to match each sphere with it's best neighbor, changing
    % the ID appropriately. Assume the same number of spheres
    BaseCOM = [BaseProperties.COM];
    for p = 1:length(Properties)
      Position = repmat ( Properties(p).COM, 1, length(Properties) );
      D = BaseCOM - Position;
      D = sum ( D.^2 );
      [bogus I] = sort ( D );
      Properties(p).Match = I(1);
    end
  end

  fn = sprintf ( '%sSeries%d.txt', Directory, series );
  fid = fopen ( fn, 'w' );
  DumpSpheres ( Properties, fid );
  fclose ( fid );
  
end


% join Series1.txt Series2.txt | join - Series3.txt | join -
% Series4.txt | join - Series5.txt 

% And the translation away from isocenter

Directory = '/home/blezek/src/MION/CalibrationData/2002-11-14-NonlinearScan/';
for series = 2:11,
  disp ( series );
  [Image, Headers] = LoadSeries ( [Directory 'RawData/'], 35, series );
  
  % Segment the spheres for this scan
  Image = squeeze ( Image );
  Properties = SegmentSpheres ( Headers(1), Image, 0.5 );

  if series == 1
    for p = 1:length(Properties)
      Properties(p).Match = p;
    end
    BaseProperties = Properties;
  else
    % Try to match each sphere with it's best neighbor, changing
    % the ID appropriately. Assume the same number of spheres
    BaseCOM = [BaseProperties.ScannerCOM];
    for p = 1:length(Properties)
      Position = repmat ( Properties(p).ScannerCOM, 1, length(Properties) );
      D = BaseCOM - Position;
      D = sum ( D.^2 );
      [bogus I] = sort ( D );
      Properties(p).Match = I(1);
    end
  end

  fn = sprintf ( '%sSeries%d.txt', Directory, series );
  fid = fopen ( fn, 'w' );
  DumpSpheres ( Properties, fid );
  fclose ( fid );
  
end
