function V = VolumeFromIsosurface(Surface)
% VolumeFromIsosurface ( Surface )
% Calculate the volume of the isosurface using Gauss's method
  

  A = Surface.vertices ( Surface.faces(:,1), : );
  B = Surface.vertices ( Surface.faces(:,2), : );
  C = Surface.vertices ( Surface.faces(:,3), : );
  
  Area = cross ( B - A, C - A );
  
  L = A + B + C;
  
  V = 1/6 * sum ( Area(:,3) .* L(:,3) );
  V = abs ( V );
  
