function varargout = get_files(filtr,outputmode)
if ~exist('filtr','var')
    filtr=pwd;
end
if ~exist('outputmode','var')
    outputmode = 'char';
end
d = dir(filtr);
e1 = struct([]);
e2 = struct([]);
for i=1:length(d)
    if ~d(i).isdir
        e1 = [e1 d(i)];
    else
        e2 = [e2 d(i)];
    end
end
dfiles = e1;
ddirs  = e2;
clear d
d = dfiles;
str = {d.name};
[s,v] = mls_listdlg('ListString',str,'PromptString','Select a file:','SelectionMode','multiple');

switch(lower(outputmode))
    case 'char'
        [filenames{1:length(s)}] = deal(d(s).name);
        varargout = {char(filenames),s,v};
    case 'dir'
        varargout = {d(s),s,v};
end
% LISTDLG  List selection dialog box.
%     [SELECTION,OK] = LISTDLG('ListString',S) creates a modal dialog box
%     which allows you to select a string or multiple strings from a list.
%     SELECTION is a vector of indices of the selected strings (length 1
%     in the single selection mode).  This will be [] when OK is 0.
%     OK is 1 if you push the OK button, or 0 if you push the Cancel 
%     button or close the figure.
%     Double-clicking on an item or pressing <CR> when multiple items are
%     selected has the same effect as clicking the OK button.
%  
%     Inputs are in parameter,value pairs:
%  
%     Parameter       Description
%     'ListString'    cell array of strings for the list box.
%     'SelectionMode' string; can be 'single' or 'multiple'; defaults to
%                     'multiple'.
%     'ListSize'      [width height] of listbox in pixels; defaults
%                     to [160 300].
%     'InitialValue'  vector of indices of which items of the list box
%                     are initially selected; defaults to the first item.
%     'Name'          String for the figure's title. Defaults to ''.
%     'PromptString'  string matrix or cell array of strings which appears 
%                     as text above the list box.  Defaults to {}.
%     'OKString'      string for the OK button; defaults to 'OK'.
%     'CancelString'  string for the Cancel button; defaults to 'Cancel'.
%     'uh'            uicontrol button height, in pixels; default = 18.
%     'fus'           frame/uicontrol spacing, in pixels; default = 8.
%     'ffs'           frame/figure spacing, in pixels; default = 8.
%  
%     A 'Select all' button is provided in the multiple selection case.
%  
%     Example:
